Index: compat/svr4/svr4_stat.c
===================================================================
RCS file: /home/ncvs/src/sys/compat/svr4/svr4_stat.c,v
retrieving revision 1.13
diff -u -r1.13 svr4_stat.c
--- compat/svr4/svr4_stat.c	17 Oct 2002 22:27:21 -0000	1.13
+++ compat/svr4/svr4_stat.c	12 Dec 2002 03:14:38 -0000
@@ -164,24 +164,24 @@
 	int			error;
 	caddr_t sg = stackgap_init();
 
-	CHECKALTEXIST(td, &sg, SCARG(uap, path));
+	CHECKALTEXIST(td, &sg, uap->path);
 
-	SCARG(&cup, path) = SCARG(uap, path);
-	SCARG(&cup, ub) = stackgap_alloc(&sg, sizeof(struct stat));
+	cup.path = uap->path;
+	cup.ub = stackgap_alloc(&sg, sizeof(struct stat));
 
 
 	if ((error = stat(td, &cup)) != 0)
 		return error;
 
-	if ((error = copyin(SCARG(&cup, ub), &st, sizeof st)) != 0)
+	if ((error = copyin(cup.ub, &st, sizeof st)) != 0)
 		return error;
 
 	bsd_to_svr4_stat(&st, &svr4_st);
 
 	if (S_ISSOCK(st.st_mode))
-		(void) svr4_add_socket(td, SCARG(uap, path), &st);
+		(void) svr4_add_socket(td, uap->path, &st);
 
-	if ((error = copyout(&svr4_st, SCARG(uap, ub), sizeof svr4_st)) != 0)
+	if ((error = copyout(&svr4_st, uap->ub, sizeof svr4_st)) != 0)
 		return error;
 
 	return 0;
@@ -199,23 +199,23 @@
 	int			error;
 	caddr_t			sg = stackgap_init();
 
-	CHECKALTEXIST(td, &sg, SCARG(uap, path));
+	CHECKALTEXIST(td, &sg, uap->path);
 
-	SCARG(&cup, path) = SCARG(uap, path);
-	SCARG(&cup, ub) = stackgap_alloc(&sg, sizeof(struct stat));
+	cup.path = uap->path;
+	cup.ub = stackgap_alloc(&sg, sizeof(struct stat));
 
 	if ((error = lstat(td, &cup)) != 0)
 		return error;
 
-	if ((error = copyin(SCARG(&cup, ub), &st, sizeof st)) != 0)
+	if ((error = copyin(cup.ub, &st, sizeof st)) != 0)
 		return error;
 
 	bsd_to_svr4_stat(&st, &svr4_st);
 
 	if (S_ISSOCK(st.st_mode))
-		(void) svr4_add_socket(td, SCARG(uap, path), &st);
+		(void) svr4_add_socket(td, uap->path, &st);
 
-	if ((error = copyout(&svr4_st, SCARG(uap, ub), sizeof svr4_st)) != 0)
+	if ((error = copyout(&svr4_st, uap->ub, sizeof svr4_st)) != 0)
 		return error;
 
 	return 0;
@@ -233,18 +233,18 @@
 	int			error;
 	caddr_t			sg = stackgap_init();
 
-	SCARG(&cup, fd) = SCARG(uap, fd);
-	SCARG(&cup, sb) = stackgap_alloc(&sg, sizeof(struct stat));
+	cup.fd = uap->fd;
+	cup.sb = stackgap_alloc(&sg, sizeof(struct stat));
 
 	if ((error = fstat(td, &cup)) != 0)
 		return error;
 
-	if ((error = copyin(SCARG(&cup, sb), &st, sizeof st)) != 0)
+	if ((error = copyin(cup.sb, &st, sizeof st)) != 0)
 		return error;
 
 	bsd_to_svr4_stat(&st, &svr4_st);
 
-	if ((error = copyout(&svr4_st, SCARG(uap, sb), sizeof svr4_st)) != 0)
+	if ((error = copyout(&svr4_st, uap->sb, sizeof svr4_st)) != 0)
 		return error;
 
 	return 0;
@@ -262,25 +262,25 @@
 	int			error;
 
 	caddr_t sg = stackgap_init();
-	CHECKALTEXIST(td, &sg, SCARG(uap, path));
+	CHECKALTEXIST(td, &sg, uap->path);
 
-	SCARG(&cup, path) = SCARG(uap, path);
-	SCARG(&cup, ub) = stackgap_alloc(&sg, sizeof(struct stat));
+	cup.path = uap->path;
+	cup.ub = stackgap_alloc(&sg, sizeof(struct stat));
 
 	if ((error = stat(td, &cup)) != 0)
 		return error;
 
-	if ((error = copyin(SCARG(&cup, ub), &st, sizeof st)) != 0)
+	if ((error = copyin(cup.ub, &st, sizeof st)) != 0)
 		return error;
 
 	bsd_to_svr4_xstat(&st, &svr4_st);
 
 #if defined(SOCKET_NOTYET)
 	if (S_ISSOCK(st.st_mode))
-		(void) svr4_add_socket(td, SCARG(uap, path), &st);
+		(void) svr4_add_socket(td, uap->path, &st);
 #endif
 
-	if ((error = copyout(&svr4_st, SCARG(uap, ub), sizeof svr4_st)) != 0)
+	if ((error = copyout(&svr4_st, uap->ub, sizeof svr4_st)) != 0)
 		return error;
 
 	return 0;
@@ -296,24 +296,24 @@
 	struct lstat_args	cup;
 	int			error;
 	caddr_t sg = stackgap_init();
-	CHECKALTEXIST(td, &sg, SCARG(uap, path));
+	CHECKALTEXIST(td, &sg, uap->path);
 
-	SCARG(&cup, path) = SCARG(uap, path);
-	SCARG(&cup, ub) = stackgap_alloc(&sg, sizeof(struct stat));
+	cup.path = uap->path;
+	cup.ub = stackgap_alloc(&sg, sizeof(struct stat));
 
 	if ((error = lstat(td, &cup)) != 0)
 		return error;
 
-	if ((error = copyin(SCARG(&cup, ub), &st, sizeof st)) != 0)
+	if ((error = copyin(cup.ub, &st, sizeof st)) != 0)
 		return error;
 
 	bsd_to_svr4_xstat(&st, &svr4_st);
 
 #if defined(SOCKET_NOTYET)
 	if (S_ISSOCK(st.st_mode))
-		(void) svr4_add_socket(td, SCARG(uap, path), &st);
+		(void) svr4_add_socket(td, uap->path, &st);
 #endif
-	if ((error = copyout(&svr4_st, SCARG(uap, ub), sizeof svr4_st)) != 0)
+	if ((error = copyout(&svr4_st, uap->ub, sizeof svr4_st)) != 0)
 		return error;
 
 	return 0;
@@ -332,18 +332,18 @@
 
 	caddr_t sg = stackgap_init();
 
-	SCARG(&cup, fd) = SCARG(uap, fd);
-	SCARG(&cup, sb) = stackgap_alloc(&sg, sizeof(struct stat));
+	cup.fd = uap->fd;
+	cup.sb = stackgap_alloc(&sg, sizeof(struct stat));
 
 	if ((error = fstat(td, &cup)) != 0)
 		return error;
 
-	if ((error = copyin(SCARG(&cup, sb), &st, sizeof st)) != 0)
+	if ((error = copyin(cup.sb, &st, sizeof st)) != 0)
 		return error;
 
 	bsd_to_svr4_xstat(&st, &svr4_st);
 
-	if ((error = copyout(&svr4_st, SCARG(uap, sb), sizeof svr4_st)) != 0)
+	if ((error = copyout(&svr4_st, uap->sb, sizeof svr4_st)) != 0)
 		return error;
 
 	return 0;
@@ -360,23 +360,23 @@
 	int			error;
 	caddr_t			sg = stackgap_init();
 
-	CHECKALTEXIST(td, &sg, SCARG(uap, path));
+	CHECKALTEXIST(td, &sg, uap->path);
 
-	SCARG(&cup, path) = SCARG(uap, path);
-	SCARG(&cup, ub) = stackgap_alloc(&sg, sizeof(struct stat));
+	cup.path = uap->path;
+	cup.ub = stackgap_alloc(&sg, sizeof(struct stat));
 
 	if ((error = stat(td, &cup)) != 0)
 		return error;
 
-	if ((error = copyin(SCARG(&cup, ub), &st, sizeof st)) != 0)
+	if ((error = copyin(cup.ub, &st, sizeof st)) != 0)
 		return error;
 
 	bsd_to_svr4_stat64(&st, &svr4_st);
 
 	if (S_ISSOCK(st.st_mode))
-		(void) svr4_add_socket(td, SCARG(uap, path), &st);
+		(void) svr4_add_socket(td, uap->path, &st);
 
-	if ((error = copyout(&svr4_st, SCARG(uap, sb), sizeof svr4_st)) != 0)
+	if ((error = copyout(&svr4_st, uap->sb, sizeof svr4_st)) != 0)
 		return error;
 
 	return 0;
@@ -394,23 +394,23 @@
 	int			error;
 	caddr_t			sg = stackgap_init();
 
-	CHECKALTEXIST(td, &sg, (char *) SCARG(uap, path));
+	CHECKALTEXIST(td, &sg, (char *) uap->path);
 
-	SCARG(&cup, path) = SCARG(uap, path);
-	SCARG(&cup, ub) = stackgap_alloc(&sg, sizeof(struct stat));
+	cup.path = uap->path;
+	cup.ub = stackgap_alloc(&sg, sizeof(struct stat));
 
 	if ((error = lstat(td, (struct lstat_args *)&cup)) != 0)
 		return error;
 
-	if ((error = copyin(SCARG(&cup, ub), &st, sizeof st)) != 0)
+	if ((error = copyin(cup.ub, &st, sizeof st)) != 0)
 		return error;
 
 	bsd_to_svr4_stat64(&st, &svr4_st);
 
 	if (S_ISSOCK(st.st_mode))
-		(void) svr4_add_socket(td, SCARG(uap, path), &st);
+		(void) svr4_add_socket(td, uap->path, &st);
 
-	if ((error = copyout(&svr4_st, SCARG(uap, sb), sizeof svr4_st)) != 0)
+	if ((error = copyout(&svr4_st, uap->sb, sizeof svr4_st)) != 0)
 		return error;
 
 	return 0;
@@ -428,18 +428,18 @@
 	int			error;
 	caddr_t sg = stackgap_init();
 
-	SCARG(&cup, fd) = SCARG(uap, fd);
-	SCARG(&cup, sb) = stackgap_alloc(&sg, sizeof(struct stat));
+	cup.fd = uap->fd;
+	cup.sb = stackgap_alloc(&sg, sizeof(struct stat));
 
 	if ((error = fstat(td, &cup)) != 0)
 		return error;
 
-	if ((error = copyin(SCARG(&cup, sb), &st, sizeof st)) != 0)
+	if ((error = copyin(cup.sb, &st, sizeof st)) != 0)
 		return error;
 
 	bsd_to_svr4_stat64(&st, &svr4_st);
 
-	if ((error = copyout(&svr4_st, SCARG(uap, sb), sizeof svr4_st)) != 0)
+	if ((error = copyout(&svr4_st, uap->sb, sizeof svr4_st)) != 0)
 		return error;
 
 	return 0;
@@ -460,7 +460,7 @@
          * XXX: should set f_tfree and f_tinode at least
          * How do we translate dev -> fstat? (and then to svr4_ustat)
          */
-	if ((error = copyout(&us, SCARG(uap, name), sizeof us)) != 0)
+	if ((error = copyout(&us, uap->name, sizeof us)) != 0)
 		return (error);
 
 	return 0;
@@ -483,7 +483,7 @@
 	strlcpy(sut.version, version, sizeof(sut.version));
 	strlcpy(sut.machine, machine, sizeof(sut.machine));
 
-	return copyout((caddr_t) &sut, (caddr_t) SCARG(uap, name),
+	return copyout((caddr_t) &sut, (caddr_t) uap->name,
 		       sizeof(struct svr4_utsname));
 }
 
@@ -499,9 +499,9 @@
 	char		buf[1];   /* XXX NetBSD uses 256, but that seems
 				     like awfully excessive kstack usage
 				     for an empty string... */
-	u_int		rlen = SCARG(uap, len);
+	u_int		rlen = uap->len;
 
-	switch (SCARG(uap, what)) {
+	switch (uap->what) {
 	case SVR4_SI_SYSNAME:
 		str = ostype;
 		break;
@@ -554,13 +554,13 @@
 		if ((error = suser(td)) != 0)
 			return error;
 		name = KERN_HOSTNAME;
-		return kern_sysctl(&name, 1, 0, 0, SCARG(uap, buf), rlen, td);
+		return kern_sysctl(&name, 1, 0, 0, uap->buf, rlen, td);
 
 	case SVR4_SI_SET_SRPC_DOMAIN:
 		if ((error = suser(td)) != 0)
 			return error;
 		name = KERN_NISDOMAINNAME;
-		return kern_sysctl(&name, 1, 0, 0, SCARG(uap, buf), rlen, td);
+		return kern_sysctl(&name, 1, 0, 0, uap->buf, rlen, td);
 #else
 	case SVR4_SI_SET_HOSTNAME:
         case SVR4_SI_SET_SRPC_DOMAIN:
@@ -570,7 +570,7 @@
 		return 0;
 
 	default:
-		DPRINTF(("Bad systeminfo command %d\n", SCARG(uap, what)));
+		DPRINTF(("Bad systeminfo command %d\n", uap->what));
 		return ENOSYS;
 	}
 
@@ -579,13 +579,13 @@
 		if (len > rlen)
 			len = rlen;
 
-		if (SCARG(uap, buf)) {
-			error = copyout(str, SCARG(uap, buf), len);
+		if (uap->buf) {
+			error = copyout(str, uap->buf, len);
 			if (error)
 				return error;
 			/* make sure we are NULL terminated */
 			buf[0] = '\0';
-			error = copyout(buf, &(SCARG(uap, buf)[len - 1]), 1);
+			error = copyout(buf, &(uap->buf[len - 1]), 1);
 		}
 		else
 			error = 0;
@@ -602,19 +602,19 @@
 	register struct thread *td;
 	struct svr4_sys_utssys_args *uap;
 {
-	switch (SCARG(uap, sel)) {
+	switch (uap->sel) {
 	case 0:		/* uname(2)  */
 		{
 			struct svr4_sys_uname_args ua;
-			SCARG(&ua, name) = SCARG(uap, a1);
+			ua.name = uap->a1;
 			return svr4_sys_uname(td, &ua);
 		}
 
 	case 2:		/* ustat(2)  */
 		{
 			struct svr4_ustat_args ua;
-			SCARG(&ua, dev) = (svr4_dev_t) SCARG(uap, a2);
-			SCARG(&ua, name) = SCARG(uap, a1);
+			ua.dev = (svr4_dev_t) uap->a2;
+			ua.name = uap->a1;
 			return svr4_ustat(td, &ua);
 		}
 
@@ -640,10 +640,10 @@
 	caddr_t sg = stackgap_init();
 	void *ttp;
 
-	CHECKALTEXIST(td, &sg, SCARG(uap, path));
-	SCARG(&ap, path) = SCARG(uap, path);
-	if (SCARG(uap, ubuf) != NULL) {
-		if ((error = copyin(SCARG(uap, ubuf), &ub, sizeof(ub))) != 0)
+	CHECKALTEXIST(td, &sg, uap->path);
+	ap.path = uap->path;
+	if (uap->ubuf != NULL) {
+		if ((error = copyin(uap->ubuf, &ub, sizeof(ub))) != 0)
 			return error;
 		tbuf[0].tv_sec = ub.actime;
 		tbuf[0].tv_usec = 0;
@@ -653,10 +653,10 @@
 		error = copyout(tbuf, ttp, sizeof(tbuf));
 		if (error)
 			return error;
-		SCARG(&ap, tptr) = ttp;
+		ap.tptr = ttp;
 	}
 	else
-		SCARG(&ap, tptr) = NULL;
+		ap.tptr = NULL;
 	return utimes(td, &ap);
 }
 
@@ -667,7 +667,7 @@
 	struct svr4_sys_utimes_args *uap;
 {
 	caddr_t sg = stackgap_init();
-	CHECKALTEXIST(td, &sg, SCARG(uap, path));
+	CHECKALTEXIST(td, &sg, uap->path);
 	return utimes(td, (struct utimes_args *)uap);
 }
 
@@ -728,11 +728,11 @@
 	caddr_t		sg = stackgap_init();
 	register_t	*retval = td->td_retval;
 
-	CHECKALTEXIST(td, &sg, SCARG(uap, path));
+	CHECKALTEXIST(td, &sg, uap->path);
 
-	SCARG(uap, name) = svr4_to_bsd_pathconf(SCARG(uap, name));
+	uap->name = svr4_to_bsd_pathconf(uap->name);
 
-	switch (SCARG(uap, name)) {
+	switch (uap->name) {
 	case -1:
 		*retval = -1;
 		return EINVAL;
@@ -752,9 +752,9 @@
 {
         register_t	*retval = td->td_retval;
 
-	SCARG(uap, name) = svr4_to_bsd_pathconf(SCARG(uap, name));
+	uap->name = svr4_to_bsd_pathconf(uap->name);
 
-	switch (SCARG(uap, name)) {
+	switch (uap->name) {
 	case -1:
 		*retval = -1;
 		return EINVAL;
Index: compat/svr4/svr4_stream.c
===================================================================
RCS file: /home/ncvs/src/sys/compat/svr4/svr4_stream.c,v
retrieving revision 1.36
diff -u -r1.36 svr4_stream.c
--- compat/svr4/svr4_stream.c	6 Oct 2002 14:39:14 -0000	1.36
+++ compat/svr4/svr4_stream.c	12 Dec 2002 03:14:38 -0000
@@ -524,17 +524,17 @@
 	void *tpath;
 
 	tpath = stackgap_alloc(&sg, l);
-	SCARG(&la, ub) = stackgap_alloc(&sg, sizeof(struct stat));
+	la.ub = stackgap_alloc(&sg, sizeof(struct stat));
 
 	if ((error = copyout(path, tpath, l)) != 0)
 		return error;
 
-	SCARG(&la, path) = tpath;
+	la.path = tpath;
 
 	if ((error = lstat(td, &la)) != 0)
 		return 0;
 
-	if ((error = copyin(SCARG(&la, ub), &st, sizeof(st))) != 0)
+	if ((error = copyin(la.ub, &st, sizeof(st))) != 0)
 		return 0;
 
 	/*
@@ -546,7 +546,7 @@
 	if ((st.st_mode & ALLPERMS) != 0)
 		return 0;
 
-	SCARG(&ua, path) = SCARG(&la, path);
+	ua.path = la.path;
 
 	if ((error = unlink(td, &ua)) != 0) {
 		DPRINTF(("clean_pipe: unlink failed %d\n", error));
@@ -773,9 +773,9 @@
 	/*
 	 * We are making assumptions again...
 	 */
-	SCARG(&la, s) = fd;
+	la.s = fd;
 	DPRINTF(("SI_LISTEN: fileno %d backlog = %d\n", fd, 5));
-	SCARG(&la, backlog) = 5;
+	la.backlog = 5;
 
 	if ((error = listen(td, &la)) != 0) {
 		DPRINTF(("SI_LISTEN: listen failed %d\n", error));
@@ -880,16 +880,16 @@
 	int error;
 	struct shutdown_args ap;
 
-	if (ioc->len != sizeof(SCARG(&ap, how))) {
+	if (ioc->len != sizeof(ap.how)) {
 		DPRINTF(("SI_SHUTDOWN: Wrong size %d != %d\n",
-			 sizeof(SCARG(&ap, how)), ioc->len));
+			 sizeof(ap.how), ioc->len));
 		return EINVAL;
 	}
 
-	if ((error = copyin(ioc->buf, &SCARG(&ap, how), ioc->len)) != 0)
+	if ((error = copyin(ioc->buf, &ap.how, ioc->len)) != 0)
 		return error;
 
-	SCARG(&ap, s) = fd;
+	ap.s = fd;
 
 	return shutdown(td, &ap);
 }
@@ -1066,10 +1066,10 @@
 	if ((error = copyout(skp, sup, sasize)) != 0)
 		return error;
 
-	SCARG(&ba, s) = fd;
+	ba.s = fd;
 	DPRINTF(("TI_BIND: fileno %d\n", fd));
-	SCARG(&ba, name) = (void *) sup;
-	SCARG(&ba, namelen) = sasize;
+	ba.name = (void *) sup;
+	ba.namelen = sasize;
 
 	if ((error = bind(td, &ba)) != 0) {
 		DPRINTF(("TI_BIND: bind failed %d\n", error));
@@ -1186,9 +1186,9 @@
 		DPRINTF(("TI_GETMYNAME\n"));
 		{
 			struct getsockname_args ap;
-			SCARG(&ap, fdes) = fd;
-			SCARG(&ap, asa) = sup;
-			SCARG(&ap, alen) = lenp;
+			ap.fdes = fd;
+			ap.asa = sup;
+			ap.alen = lenp;
 			if ((error = getsockname(td, &ap)) != 0) {
 				DPRINTF(("ti_ioctl: getsockname error\n"));
 				return error;
@@ -1200,9 +1200,9 @@
 		DPRINTF(("TI_GETPEERNAME\n"));
 		{
 			struct getpeername_args ap;
-			SCARG(&ap, fdes) = fd;
-			SCARG(&ap, asa) = sup;
-			SCARG(&ap, alen) = lenp;
+			ap.fdes = fd;
+			ap.asa = sup;
+			ap.alen = lenp;
 			if ((error = getpeername(td, &ap)) != 0) {
 				DPRINTF(("ti_ioctl: getpeername error\n"));
 				return error;
@@ -1334,8 +1334,8 @@
 		return error;
 	}
 
-	SCARG(&d2p, from) = st->s_afd;
-	SCARG(&d2p, to) = fdi.fd;
+	d2p.from = st->s_afd;
+	d2p.to = fdi.fd;
 
 	if ((error = dup2(td, &d2p)) != 0) {
 		DPRINTF(("fdinsert: dup2(%d, %d) failed %d\n", 
@@ -1343,7 +1343,7 @@
 		return error;
 	}
 
-	SCARG(&clp, fd) = st->s_afd;
+	clp.fd = st->s_afd;
 
 	if ((error = close(td, &clp)) != 0) {
 		DPRINTF(("fdinsert: close(%d) failed %d\n", 
@@ -1376,8 +1376,8 @@
 	 * ``reserve'' it. I don't know how this get reserved inside
 	 * the kernel, but we are going to create it nevertheless.
 	 */
-	SCARG(&ap, path) = dat;
-	SCARG(&ap, mode) = S_IFIFO;
+	ap.path = dat;
+	ap.mode = S_IFIFO;
 
 	return mkfifo(td, &ap);
 }
@@ -1397,7 +1397,7 @@
 	 * This is a supposed to be a kernel and library only ioctl.
 	 * I guess it is supposed to release the socket.
 	 */
-	SCARG(&ap, path) = dat;
+	ap.path = dat;
 
 	return unlink(td, &ap);
 }
@@ -1473,8 +1473,8 @@
 		return EINVAL;
 	}
 	/* get old status flags */
-	SCARG(&fa, fd) = fd;
-	SCARG(&fa, cmd) = F_GETFL;
+	fa.fd = fd;
+	fa.cmd = F_GETFL;
 	if ((error = fcntl(td, &fa)) != 0)
 		return error;
 
@@ -1502,8 +1502,8 @@
 
 	/* set the new flags, if changed */
 	if (flags != oflags) {
-		SCARG(&fa, cmd) = F_SETFL;
-		SCARG(&fa, arg) = (long) flags;
+		fa.cmd = F_SETFL;
+		fa.arg = (long) flags;
 		if ((error = fcntl(td, &fa)) != 0)
 			  return error;
 		flags = td->td_retval[0];
@@ -1511,8 +1511,8 @@
 
 	/* set up SIGIO receiver if needed */
 	if (dat != NULL) {
-		SCARG(&fa, cmd) = F_SETOWN;
-		SCARG(&fa, arg) = (long) td->td_proc->p_pid;
+		fa.cmd = F_SETOWN;
+		fa.arg = (long) td->td_proc->p_pid;
 		return fcntl(td, &fa);
 	}
 	return 0;
@@ -1760,14 +1760,14 @@
 	retval = td->td_retval;
 
 #ifdef DEBUG_SVR4
-	show_msg(">putmsg", SCARG(uap, fd), SCARG(uap, ctl),
-		 SCARG(uap, dat), SCARG(uap, flags));
+	show_msg(">putmsg", uap->fd, uap->ctl,
+		 uap->dat, uap->flags);
 #endif /* DEBUG_SVR4 */
 
 	FILE_LOCK_ASSERT(fp, MA_NOTOWNED);
 
-	if (SCARG(uap, ctl) != NULL) {
-	  if ((error = copyin(SCARG(uap, ctl), &ctl, sizeof(ctl))) != 0) {
+	if (uap->ctl != NULL) {
+	  if ((error = copyin(uap->ctl, &ctl, sizeof(ctl))) != 0) {
 #ifdef DEBUG_SVR4
 	    uprintf("putmsg: copyin(): %d\n", error);
 #endif
@@ -1777,8 +1777,8 @@
 	else
 		ctl.len = -1;
 
-	if (SCARG(uap, dat) != NULL) {
-	  if ((error = copyin(SCARG(uap, dat), &dat, sizeof(dat))) != 0) {
+	if (uap->dat != NULL) {
+	  if ((error = copyin(uap->dat, &dat, sizeof(dat))) != 0) {
 #ifdef DEBUG_SVR4
 	    uprintf("putmsg: copyin(): %d (2)\n", error);
 #endif
@@ -1820,9 +1820,9 @@
 				 * is how it works. newton@atdot.dotat.org XXX
 				 */
 				DPRINTF(("sending expedited data ??\n"));
-				SCARG(&wa, fd) = SCARG(uap, fd);
-				SCARG(&wa, buf) = dat.buf;
-				SCARG(&wa, nbyte) = dat.len;
+				wa.fd = uap->fd;
+				wa.buf = dat.buf;
+				wa.nbyte = dat.len;
 				return write(td, &wa);
 			}
 	                DPRINTF(("putmsg: Invalid inet length %ld\n", sc.len));
@@ -1872,9 +1872,9 @@
 		{
 			struct connect_args co;
 
-			SCARG(&co, s) = SCARG(uap, fd);
-			SCARG(&co, name) = (void *) sup;
-			SCARG(&co, namelen) = (int) sasize;
+			co.s = uap->fd;
+			co.name = (void *) sup;
+			co.namelen = (int) sasize;
 			
 			return connect(td, &co);
 		}
@@ -1896,8 +1896,8 @@
 			error = so->so_proto->pr_usrreqs->pru_sosend(so, 0, 
 					      uio, 0, 0, 0, uio->uio_td);
 #endif
-			error = svr4_sendit(td, SCARG(uap, fd), &msg,
-				       SCARG(uap, flags));
+			error = svr4_sendit(td, uap->fd, &msg,
+				       uap->flags);
 			DPRINTF(("sendto_request error: %d\n", error));
 			*retval = 0;
 			return error;
@@ -1957,12 +1957,12 @@
 	memset(&sc, 0, sizeof(sc));
 
 #ifdef DEBUG_SVR4
-	show_msg(">getmsg", SCARG(uap, fd), SCARG(uap, ctl),
-		 SCARG(uap, dat), 0);
+	show_msg(">getmsg", uap->fd, uap->ctl,
+		 uap->dat, 0);
 #endif /* DEBUG_SVR4 */
 
-	if (SCARG(uap, ctl) != NULL) {
-		if ((error = copyin(SCARG(uap, ctl), &ctl, sizeof(ctl))) != 0)
+	if (uap->ctl != NULL) {
+		if ((error = copyin(uap->ctl, &ctl, sizeof(ctl))) != 0)
 			return error;
 	}
 	else {
@@ -1970,8 +1970,8 @@
 		ctl.maxlen = 0;
 	}
 
-	if (SCARG(uap, dat) != NULL) {
-	    	if ((error = copyin(SCARG(uap, dat), &dat, sizeof(dat))) != 0)
+	if (uap->dat != NULL) {
+	    	if ((error = copyin(uap->dat, &dat, sizeof(dat))) != 0)
 			return error;
 	}
 	else {
@@ -2040,9 +2040,9 @@
 		 * a connect verification.
 		 */
 
-		SCARG(&ga, fdes) = SCARG(uap, fd);
-		SCARG(&ga, asa) = (void *) sup;
-		SCARG(&ga, alen) = flen;
+		ga.fdes = uap->fd;
+		ga.asa = (void *) sup;
+		ga.alen = flen;
 		
 		if ((error = getpeername(td, &ga)) != 0) {
 			DPRINTF(("getmsg: getpeername failed %d\n", error));
@@ -2099,9 +2099,9 @@
 		/*
 		 * We are after a listen, so we try to accept...
 		 */
-		SCARG(&aa, s) = SCARG(uap, fd);
-		SCARG(&aa, name) = (void *) sup;
-		SCARG(&aa, anamelen) = flen;
+		aa.s = uap->fd;
+		aa.name = (void *) sup;
+		aa.anamelen = flen;
 		
 		if ((error = accept(td, &aa)) != 0) {
 			DPRINTF(("getmsg: accept failed %d\n", error));
@@ -2174,7 +2174,7 @@
 		aiov.iov_len = dat.maxlen;
 		msg.msg_flags = 0;
 
-		error = svr4_recvit(td, SCARG(uap, fd), &msg, (caddr_t) flen);
+		error = svr4_recvit(td, uap->fd, &msg, (caddr_t) flen);
 
 		if (error) {
 			DPRINTF(("getmsg: recvit failed %d\n", error));
@@ -2222,9 +2222,9 @@
 			 * appropriately (or inappropriately :-)
 			 *   -- newton@atdot.dotat.org        XXX
 			 */
-			SCARG(&ra, fd) = SCARG(uap, fd);
-			SCARG(&ra, buf) = dat.buf;
-			SCARG(&ra, nbyte) = dat.maxlen;
+			ra.fd = uap->fd;
+			ra.buf = dat.buf;
+			ra.nbyte = dat.maxlen;
 			if ((error = read(td, &ra)) != 0) {
 			        return error;
 			}
@@ -2237,30 +2237,30 @@
 		return EINVAL;
 	}
 
-	if (SCARG(uap, ctl)) {
+	if (uap->ctl) {
 		if (ctl.len != -1)
 			if ((error = copyout(&sc, ctl.buf, ctl.len)) != 0)
 				return error;
 
-		if ((error = copyout(&ctl, SCARG(uap, ctl), sizeof(ctl))) != 0)
+		if ((error = copyout(&ctl, uap->ctl, sizeof(ctl))) != 0)
 			return error;
 	}
 
-	if (SCARG(uap, dat)) {
-		if ((error = copyout(&dat, SCARG(uap, dat), sizeof(dat))) != 0)
+	if (uap->dat) {
+		if ((error = copyout(&dat, uap->dat, sizeof(dat))) != 0)
 			return error;
 	}
 
-	if (SCARG(uap, flags)) { /* XXX: Need translation */
-		if ((error = copyout(&fl, SCARG(uap, flags), sizeof(fl))) != 0)
+	if (uap->flags) { /* XXX: Need translation */
+		if ((error = copyout(&fl, uap->flags, sizeof(fl))) != 0)
 			return error;
 	}
 
 	*retval = 0;
 
 #ifdef DEBUG_SVR4
-	show_msg("<getmsg", SCARG(uap, fd), SCARG(uap, ctl),
-		 SCARG(uap, dat), fl);
+	show_msg("<getmsg", uap->fd, uap->ctl,
+		 uap->dat, fl);
 #endif /* DEBUG_SVR4 */
 	return error;
 }
@@ -2270,10 +2270,10 @@
 	struct svr4_sys_send_args *uap;
 {
 	struct osend_args osa;
-	SCARG(&osa, s) = SCARG(uap, s);
-	SCARG(&osa, buf) = SCARG(uap, buf);
-	SCARG(&osa, len) = SCARG(uap, len);
-	SCARG(&osa, flags) = SCARG(uap, flags);
+	osa.s = uap->s;
+	osa.buf = uap->buf;
+	osa.len = uap->len;
+	osa.flags = uap->flags;
 	return osend(td, &osa);
 }
 
@@ -2282,10 +2282,10 @@
 	struct svr4_sys_recv_args *uap;
 {
 	struct orecv_args ora;
-	SCARG(&ora, s) = SCARG(uap, s);
-	SCARG(&ora, buf) = SCARG(uap, buf);
-	SCARG(&ora, len) = SCARG(uap, len);
-	SCARG(&ora, flags) = SCARG(uap, flags);
+	ora.s = uap->s;
+	ora.buf = uap->buf;
+	ora.len = uap->len;
+	ora.flags = uap->flags;
 	return orecv(td, &ora);
 }
 
@@ -2300,12 +2300,12 @@
 {
         struct sendto_args sa;
 
-	SCARG(&sa, s) = SCARG(uap, s);
-	SCARG(&sa, buf) = SCARG(uap, buf);
-	SCARG(&sa, len) = SCARG(uap, len);
-	SCARG(&sa, flags) = SCARG(uap, flags);
-	SCARG(&sa, to) = (caddr_t)SCARG(uap, to);
-	SCARG(&sa, tolen) = SCARG(uap, tolen);
+	sa.s = uap->s;
+	sa.buf = uap->buf;
+	sa.len = uap->len;
+	sa.flags = uap->flags;
+	sa.to = (caddr_t)uap->to;
+	sa.tolen = uap->tolen;
 
 	DPRINTF(("calling sendto()\n"));
 	return sendto(td, &sa);
Index: dev/streams/streams.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/streams/streams.c,v
retrieving revision 1.30
diff -u -r1.30 streams.c
--- dev/streams/streams.c	20 Mar 2002 02:07:43 -0000	1.30
+++ dev/streams/streams.c	12 Dec 2002 03:14:38 -0000
@@ -315,9 +315,9 @@
 	register_t fd = -1;
 	int error;
 
-	SCARG(&oa, path) = path;
-	SCARG(&oa, flags) = O_RDWR;
-	SCARG(&oa, mode) = 0;
+	oa.path = path;
+	oa.flags = O_RDWR;
+	oa.mode = 0;
 
 	while (fd == -1) {
 		ptyname[8] = ttyletters[l];
Index: i386/ibcs2/ibcs2_fcntl.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/ibcs2/ibcs2_fcntl.c,v
retrieving revision 1.21
diff -u -r1.21 ibcs2_fcntl.c
--- i386/ibcs2/ibcs2_fcntl.c	17 Aug 2002 02:36:16 -0000	1.21
+++ i386/ibcs2/ibcs2_fcntl.c	12 Dec 2002 03:14:38 -0000
@@ -174,20 +174,20 @@
 	struct ibcs2_open_args *uap;
 {
 	struct proc *p = td->td_proc;
-	int noctty = SCARG(uap, flags) & IBCS2_O_NOCTTY;
+	int noctty = uap->flags & IBCS2_O_NOCTTY;
 	int ret;
 	caddr_t sg = stackgap_init();
 
-	SCARG(uap, flags) = cvt_o_flags(SCARG(uap, flags));
-	if (SCARG(uap, flags) & O_CREAT)
-		CHECKALTCREAT(td, &sg, SCARG(uap, path));
+	uap->flags = cvt_o_flags(uap->flags);
+	if (uap->flags & O_CREAT)
+		CHECKALTCREAT(td, &sg, uap->path);
 	else
-		CHECKALTEXIST(td, &sg, SCARG(uap, path));
+		CHECKALTEXIST(td, &sg, uap->path);
 	ret = open(td, (struct open_args *)uap);
 
 #ifdef SPX_HACK
 	if (ret == ENXIO) {
-		if (!strcmp(SCARG(uap, path), "/compat/ibcs2/dev/spx"))
+		if (!strcmp(uap->path, "/compat/ibcs2/dev/spx"))
 			ret = spx_open(td, uap);
 	} else
 #endif /* SPX_HACK */
@@ -219,10 +219,10 @@
 	struct open_args cup;   
 	caddr_t sg = stackgap_init();
 
-	CHECKALTCREAT(td, &sg, SCARG(uap, path));
-	SCARG(&cup, path) = SCARG(uap, path);
-	SCARG(&cup, mode) = SCARG(uap, mode);
-	SCARG(&cup, flags) = O_WRONLY | O_CREAT | O_TRUNC;
+	CHECKALTCREAT(td, &sg, uap->path);
+	cup.path = uap->path;
+	cup.mode = uap->mode;
+	cup.flags = O_WRONLY | O_CREAT | O_TRUNC;
 	return open(td, &cup);
 }       
 
@@ -234,9 +234,9 @@
         struct access_args cup;
         caddr_t sg = stackgap_init();
 
-        CHECKALTEXIST(td, &sg, SCARG(uap, path));
-        SCARG(&cup, path) = SCARG(uap, path);
-        SCARG(&cup, flags) = SCARG(uap, flags);
+        CHECKALTEXIST(td, &sg, uap->path);
+        cup.path = uap->path;
+        cup.flags = uap->flags;
         return access(td, &cup);
 }
 
@@ -250,55 +250,55 @@
 	struct flock *flp;
 	struct ibcs2_flock ifl;
 	
-	switch(SCARG(uap, cmd)) {
+	switch(uap->cmd) {
 	case IBCS2_F_DUPFD:
-		SCARG(&fa, fd) = SCARG(uap, fd);
-		SCARG(&fa, cmd) = F_DUPFD;
-		SCARG(&fa, arg) = (/* XXX */ int)SCARG(uap, arg);
+		fa.fd = uap->fd;
+		fa.cmd = F_DUPFD;
+		fa.arg = (/* XXX */ int)uap->arg;
 		return fcntl(td, &fa);
 	case IBCS2_F_GETFD:
-		SCARG(&fa, fd) = SCARG(uap, fd);
-		SCARG(&fa, cmd) = F_GETFD;
-		SCARG(&fa, arg) = (/* XXX */ int)SCARG(uap, arg);
+		fa.fd = uap->fd;
+		fa.cmd = F_GETFD;
+		fa.arg = (/* XXX */ int)uap->arg;
 		return fcntl(td, &fa);
 	case IBCS2_F_SETFD:
-		SCARG(&fa, fd) = SCARG(uap, fd);
-		SCARG(&fa, cmd) = F_SETFD;
-		SCARG(&fa, arg) = (/* XXX */ int)SCARG(uap, arg);
+		fa.fd = uap->fd;
+		fa.cmd = F_SETFD;
+		fa.arg = (/* XXX */ int)uap->arg;
 		return fcntl(td, &fa);
 	case IBCS2_F_GETFL:
-		SCARG(&fa, fd) = SCARG(uap, fd);
-		SCARG(&fa, cmd) = F_GETFL;
-		SCARG(&fa, arg) = (/* XXX */ int)SCARG(uap, arg);
+		fa.fd = uap->fd;
+		fa.cmd = F_GETFL;
+		fa.arg = (/* XXX */ int)uap->arg;
 		error = fcntl(td, &fa);
 		if (error)
 			return error;
 		td->td_retval[0] = oflags2ioflags(td->td_retval[0]);
 		return error;
 	case IBCS2_F_SETFL:
-		SCARG(&fa, fd) = SCARG(uap, fd);
-		SCARG(&fa, cmd) = F_SETFL;
-		SCARG(&fa, arg) = (/* XXX */ int)
-				  ioflags2oflags((int)SCARG(uap, arg));
+		fa.fd = uap->fd;
+		fa.cmd = F_SETFL;
+		fa.arg = (/* XXX */ int)
+				  ioflags2oflags((int)uap->arg);
 		return fcntl(td, &fa);
 
 	case IBCS2_F_GETLK:
 	    {
 		caddr_t sg = stackgap_init();
 		flp = stackgap_alloc(&sg, sizeof(*flp));
-		error = copyin((caddr_t)SCARG(uap, arg), (caddr_t)&ifl,
+		error = copyin((caddr_t)uap->arg, (caddr_t)&ifl,
 			       ibcs2_flock_len);
 		if (error)
 			return error;
 		cvt_iflock2flock(&ifl, flp);
-		SCARG(&fa, fd) = SCARG(uap, fd);
-		SCARG(&fa, cmd) = F_GETLK;
-		SCARG(&fa, arg) = (/* XXX */ int)flp;
+		fa.fd = uap->fd;
+		fa.cmd = F_GETLK;
+		fa.arg = (/* XXX */ int)flp;
 		error = fcntl(td, &fa);
 		if (error)
 			return error;
 		cvt_flock2iflock(flp, &ifl);
-		return copyout((caddr_t)&ifl, (caddr_t)SCARG(uap, arg),
+		return copyout((caddr_t)&ifl, (caddr_t)uap->arg,
 			       ibcs2_flock_len);
 	    }
 
@@ -306,14 +306,14 @@
 	    {
 		caddr_t sg = stackgap_init();
 		flp = stackgap_alloc(&sg, sizeof(*flp));
-		error = copyin((caddr_t)SCARG(uap, arg), (caddr_t)&ifl,
+		error = copyin((caddr_t)uap->arg, (caddr_t)&ifl,
 			       ibcs2_flock_len);
 		if (error)
 			return error;
 		cvt_iflock2flock(&ifl, flp);
-		SCARG(&fa, fd) = SCARG(uap, fd);
-		SCARG(&fa, cmd) = F_SETLK;
-		SCARG(&fa, arg) = (/* XXX */ int)flp;
+		fa.fd = uap->fd;
+		fa.cmd = F_SETLK;
+		fa.arg = (/* XXX */ int)flp;
 
 		return fcntl(td, &fa);
 	    }
@@ -322,14 +322,14 @@
 	    {
 		caddr_t sg = stackgap_init();
 		flp = stackgap_alloc(&sg, sizeof(*flp));
-		error = copyin((caddr_t)SCARG(uap, arg), (caddr_t)&ifl,
+		error = copyin((caddr_t)uap->arg, (caddr_t)&ifl,
 			       ibcs2_flock_len);
 		if (error)
 			return error;
 		cvt_iflock2flock(&ifl, flp);
-		SCARG(&fa, fd) = SCARG(uap, fd);
-		SCARG(&fa, cmd) = F_SETLKW;
-		SCARG(&fa, arg) = (/* XXX */ int)flp;
+		fa.fd = uap->fd;
+		fa.cmd = F_SETLKW;
+		fa.arg = (/* XXX */ int)flp;
 		return fcntl(td, &fa);
 	    }
 	}
